#ifndef FW_INCLUDED
#define FW_INCLUDED

#include <sys/types.h>

#define MAGIC_HEADER	"GEOS"
#define MAGIC_OPEN_HEADER	"OPEN"
#define MAGIC_UBNT_HEADER	"UBNT"
#define MAGIC_PART	"PART"
#define MAGIC_END	"END."
#define MAGIC_SCRIPT	"EXEC"

#define MAGIC_LENGTH	4

#define SCRIPT_TAR      0
#define SCRIPT_TGZ      1

typedef struct header {
        char magic[MAGIC_LENGTH];
        char version[256];
        u_int32_t crc;
        u_int32_t pad;
} __attribute__ ((packed)) header_t;

typedef struct part {
	char magic[MAGIC_LENGTH];
	char name[16];
	char pad[12];
	u_int32_t memaddr;
	u_int32_t part_no;
	u_int32_t baseaddr;
	u_int32_t entryaddr;
	u_int32_t length;
	u_int32_t part_len;
} __attribute__ ((packed)) part_t;

typedef struct part_crc {
        u_int32_t crc;
        u_int32_t pad;
} __attribute__ ((packed)) part_crc_t;

typedef struct signature {
        char magic[MAGIC_LENGTH];
        u_int32_t crc;
        u_int32_t pad;
} __attribute__ ((packed)) signature_t;

#endif
